package main

import (
	"fmt"
	"time"

	gps "hnyfkj.com.cn/rtu/linux/air530z"
	baseapp "hnyfkj.com.cn/rtu/linux/baseapp"
	camera1 "hnyfkj.com.cn/rtu/linux/mvs_u_takephoto" // 海康U口相机
	netmgrd "hnyfkj.com.cn/rtu/linux/netmgrd"
)

func main() {
	if baseapp.IsArgsParam("-h") {
		help()
		return
	}

	if baseapp.IsArgsParam("-v") {
		fmt.Println("程序版本:", baseapp.Version, "\n构建时间:", baseapp.BuildTime)
		return
	}

	baseapp.ModuleInit()
	baseapp.SingleInstanceRun() // 异步非阻塞
	baseapp.Logger.Infof("程序版本: %s 构建时间: %s\n程序开始运行...",
		baseapp.Version, baseapp.BuildTime)

	// 01, 初始化卫星定位模块
	gps.ModuleInit()

	// 02, 初始化4G调制解调器
	if !netmgrd.ModemInit() {
		goto end_p
	}

	// 03, 初始化网络管理模块
	netmgrd.ModuleInit()
	netmgrd.WaitAllOK(time.Duration(10) * time.Second) // 等待联网成功和NTP时间同步成功

	// 04, 初始化相机拍照模块
	if !camera1.ModuleInit() {
		goto end_p
	}

	// 05, 初始化单片机控制板, Todo: 根据项目不同, 使用的控制版硬件和协议都不同, 具体看情况

	// 06, 后台服务器业务交互, Todo: 根据项目不同, 实现具体的业务逻辑协议都不同, 具体看情况

	// 07, 阻塞等待退出信号量
	<-baseapp.IsExit2()

	// 08, 退出程序并释放资源
end_p:
	netmgrd.ModemExit()
	gps.ModuleExit()

	baseapp.Logger.Info("程序退出")
	baseapp.ExitLogger() // 安全的关闭日志模块
}

func help() {
	h := `
-h 显示帮助提示
-v 当前程序版本
`

	fmt.Println(h)
}
